/* gInfo - Copyright (C) 2004-5 bakunin - Andrea Marchesini 
 *                                        <bakunin@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#else
# error Use configure; make; make install
#endif

#include "ginfo.h"

/* This function inserts in the module struct the single chapters 
 * The first element is the array of docs, the 2nd is the size of 
 * array, and the last parameter is the module struct. 
 *
 * The C (or XML) modules give me an array of docs, but i need a
 * list.
 */
int
docs_add (ginfo_docs * list, int n, module * m)
{
  doc *t;
  int err = 0;

  if (!n)
    return 1;

  while (n)
    {
      if (!list->func)
	{
	  err = 1;
	  break;
	}

      if (!(t = (doc *) malloc (sizeof (doc))))
	fatal ("Error: memory.");

      t->text = list->text;
      t->func = list->func;
      t->arg = list->arg;
      t->id = list->id;

      list++;
      n--;

      t->next = NULL;

      if (!m->docs)
	{
	  m->docs = m->docs_last = t;
	}
      else
	{
	  m->docs_last->next = t;
	  m->docs_last = t;
	}
    }

  if (err)
    {
      while (m->docs)
	{

	  t = m->docs;
	  m->docs = m->docs->next;

	  free (t);
	}
    }

  return err;
}

/* EOF */
